-- catmull-rom spline curve drawing
 
-- turn off status display bar
display.setStatusBar(display.HiddenStatusBar)
 
local catmull = require("catmull")
require("displayex")
require("mathlib")
 
local bar, content = display.newGroup(), display.newGroup()
local curve, control = display.newGroup(), display.newGroup()
content:insert(curve)
content:insert(control)
 
red.a = 150
aspoints = true
isopen = true
 
local pts = {}
 
-- create an input bar
function createBar(index,title,callback,initval,min,max)
        local group = display.newGroup()
        group.y = index * 100
        local titletxt = display.newText(group,title, 25, 0, native.systemFont, 22)
        local numtext = display.newText(group,initval, 300, 0, native.systemFont, 22)
        local rect = display.newRoundedRect( group, 0, 0, 20, 50, 10 )
        rect.x, rect.y = (display.contentWidth-100) / (max-min) * initval + 50, 50
        
        function touch(event)
                if (event.x >= 50 and event.x < display.contentWidth-50) then
                if (event.phase == "began") then
                        setFocus(rect)
                elseif (event.phase == "ended" or event.phase == "cancelled") then
                    setFocus(nil)
                end
                rect.x = event.x
                local val = (event.x-50)/((display.contentWidth-100)/(max-min)) + min
                numtext.text = tostring(val)
                numtext.x = 300 + numtext.width/2 + 50
                callback(val)
                return true
            end
        end
        rect:addEventListener("touch",touch)
        
        return group
end
 
-- change number of balls
function changeRate(val)
        steprate = math.round(val)
        clear(curve)
        draw( curve, smooth( pts, isopen ), blue, 5, aspoints )
end
createBar(0,"step rate",changeRate,25,1,40)
 
-- change number of balls
function changeRender(val)
        aspoints = val >= 1
        clear(curve)
        draw( curve, smooth( pts, isopen ), blue, 5, aspoints )
end
createBar(1,"is points",changeRender,1.1,0,2)
 
-- continuous or open
function changeOpen(val)
        isopen = val >= 1
        clear(curve)
        draw( curve, smooth( pts, isopen ), blue, 5, aspoints )
end
createBar(2,"is open",changeOpen,1.1,0,2)
 
function pointtap(event)
        return true
end
 
function pointtouch(event)
        if (event.phase == "began") then
                setFocus( event.target )
        elseif (event.phase == "moved") then
        else
                setFocus( nil )
        end
        
        event.target.x, event.target.y = event.x, event.y
        
        local index = display.indexOf( control, event.target )
        local c = pts[ index ]
        c.x, c.y = event.x, event.y
        
        clear(curve)
        draw( curve, smooth( pts, isopen ), blue, 5, aspoints )
        
        return true
end
 
function tap(event)
--      clear(curve)
--      clear(control)
        clear(content, true)
        pts[ #pts+1 ] = event
        draw( control, pts, red, 30, true, pointtap, pointtouch )
        draw( curve, smooth( pts, isopen ), blue, 5, aspoints )
        return true
end
 
Runtime:addEventListener("tap", tap)